function TotalGold_OnLoad()
	SlashCmdList["TOTALGOLD"] = TotalGold_Command;
	SLASH_TOTALGOLD1 = "/totalgold";
	SLASH_TOTALGOLD2 = "/tg";

	TotalGoldFrame:RegisterEvent("VARIABLES_LOADED");
	TotalGoldFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	TotalGoldFrame:RegisterEvent("UNIT_NAME_UPDATE")
	TotalGoldFrame:RegisterEvent("PLAYER_MONEY");

	if (not TotalGoldArray) then TotalGoldArray = {}; end
end

function TotalGold_Command(msg)

	if (msg == "") then
		if (TotalGoldFrame:IsVisible()) then
			TG_LASTAMOUNT = GetMoney("player");
			TotalGoldFrame:Hide();
		else
			TG_ShowReport();
		end
		return;
	end

	if (msg == TG_CLEARALL) then
		TotalGoldArray = {};
		TG_Initialize();
		if (TotalGoldFrame:IsVisible()) then
			TG_ShowReport();
		else
			DEFAULT_CHAT_FRAME:AddMessage( TG_ALLDATAERASED, 1.0, 1.0, 0.0 );
		end
		return;
	end

	if (msg == TG_RESETSESSION) then
		TG_STARTINGGOLD = GetMoney("player");
		TG_STARTTIME = GetTime();
		if (TotalGoldFrame:IsVisible()) then
			TG_ShowReport();
		else
			DEFAULT_CHAT_FRAME:AddMessage( TG_SESSIONRESET, 1.0, 1.0, 0.0 );
		end
		return;
	end

	for _,line in TG_HELPARRAY do
		DEFAULT_CHAT_FRAME:AddMessage( line, 1.0, 1.0, 0.0 );
	end

end

function TotalGold_EventHandler()
	if (event == "VARIABLES_LOADED") then
		TG_VARIABLES_LOADED = true;
		if ( TG_ENTERINGWORLD ) then
			TG_Initialize();
		end
		return;
	end

	if ( event == "PLAYER_ENTERING_WORLD" ) then
		TG_ENTERINGWORLD = true;
		if (TG_VARIABLES_LOADED) then
			TG_Initialize();
		end
		return;
	end

	if (event == "PLAYER_MONEY") then
		if (TG_INITIALIZED) then
			TotalGoldArray[TG_INDEX] = GetMoney("player");
			if (TotalGoldFrame:IsVisible()) then
				TG_ShowReport();
			end
		end
		return;
	end
end

function TG_CheckPlayerName()
	if (TG_GOT_PLAYERNAME) then
		return true;
	end
	local pName = UnitName("player");
	if ((pName ~= nil) and (pName ~= UNKNOWNOBJECT) and (pName ~= UKNOWNBEING) and (pName ~= "Unknown Entity") ) then
		TG_GOT_PLAYERNAME = true;
		return true;
	end
	return false;
end

function TG_Initialize()
	if (TG_INITIALIZED) then return; end
	TotalGoldFrame:UnregisterEvent("VARIABLES_LOADED");
	TotalGoldFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	TotalGoldFrame:UnregisterEvent("UNIT_NAME_UPDATE");

	if (not TotalGoldArray["INITIALIZED"]) then
		TotalGoldArray = {};
		TotalGoldArray["LABELDISPLAY"] = "coins";
		TotalGoldArray["INITIALIZED"] = true;
	end

	TG_INDEX = UnitName("player").."_"..GetCVar("realmName").."::"..UnitFactionGroup("player");
	TotalGoldArray[TG_INDEX] = GetMoney("player");
	TG_STARTINGGOLD = GetMoney("player");
	TG_STARTTIME = GetTime();
	TG_LASTAMOUNT = 0;

	if (TotalGoldArray["LABELDISPLAY"] == "text") then
		TG_CoinsToggle:SetText(TG_COINS);
	end

	TG_Lines_Gold:SetText("___");
	TG_Lines_Silver:SetText("___");
	TG_Lines_Copper:SetText("___");
	TG_Lines_GoldLabel:SetText("__");
	TG_Lines_SilverLabel:SetText("__");
	TG_Lines_CopperLabel:SetText("__");
	TG_Lines_GoldLabel:Show();
	TG_Lines_SilverLabel:Show();
	TG_Lines_CopperLabel:Show();
	TG_Lines_GoldTexture:Hide();
	TG_Lines_SilverTexture:Hide();
	TG_Lines_CopperTexture:Hide();
	TG_Lines_Gold:SetTextColor(1,1,1);
	TG_Lines_Silver:SetTextColor(1,1,1);
	TG_Lines_Copper:SetTextColor(1,1,1);
	TG_Lines_GoldLabel:SetTextColor(1,1,1);
	TG_Lines_SilverLabel:SetTextColor(1,1,1);
	TG_Lines_CopperLabel:SetTextColor(1,1,1);

	TG_Total_Character:SetText(TG_TOTAL);
	TG_Session_Character:SetText(TG_SESSIONEARNINGSTEXT);
	TG_LastReport_Character:SetText(TG_OTHEREARNINGSTEXT);
	TG_EarningsPerHour_Character:SetText(TG_EARNINGSPERHOURTEXT);

	if (not TG_INITIALIZED) then
		DEFAULT_CHAT_FRAME:AddMessage(TG_LOADEDMSG, 1, 1, 0);
	end

	TG_INITIALIZED = true;
end

function TG_ShowReport()
	local server = GetCVar("realmName").."::"..UnitFactionGroup("Player");
	TG_Server:SetText(GetCVar("realmName").." ("..UnitFactionGroup("Player")..")");
	TotalGoldArray[TG_INDEX] = GetMoney("player");
	if (TG_LASTAMOUNT == 0) then TG_LASTAMOUNT = GetMoney("player"); end
	local sessiontotal = GetMoney("player") - TG_STARTINGGOLD;
	local timepassed = GetTime() - TG_STARTTIME;
	local perhour = math.floor(sessiontotal / timepassed * 3600);
	local lasttotal = GetMoney("player") - TG_LASTAMOUNT;
	local namewidth = TG_LastReport_Character:GetWidth();
	local goldwidth = TG_Lines_Gold:GetWidth();
	local silverwidth = TG_Lines_Silver:GetWidth();
	local copperwidth = TG_Lines_Copper:GetWidth();
	local totalgold = 0;

	if (TotalGoldArray["LABELDISPLAY"] == "coins") then
		for i = 1, 9 do
			getglobal("TG_Character"..i.."_GoldLabel"):Hide();
			getglobal("TG_Character"..i.."_GoldTexture"):Show();
			getglobal("TG_Character"..i.."_SilverLabel"):Hide();
			getglobal("TG_Character"..i.."_SilverTexture"):Show();
			getglobal("TG_Character"..i.."_CopperLabel"):Hide();
			getglobal("TG_Character"..i.."_CopperTexture"):Show();
		end
		TG_Total_GoldLabel:Hide();
		TG_Total_GoldTexture:Show();
		TG_Total_SilverLabel:Hide();
		TG_Total_SilverTexture:Show();
		TG_Total_CopperLabel:Hide();
		TG_Total_CopperTexture:Show();
		TG_Session_GoldLabel:Hide();
		TG_Session_GoldTexture:Show();
		TG_Session_SilverLabel:Hide();
		TG_Session_SilverTexture:Show();
		TG_Session_CopperLabel:Hide();
		TG_Session_CopperTexture:Show();
		TG_LastReport_GoldLabel:Hide();
		TG_LastReport_GoldTexture:Show();
		TG_LastReport_SilverLabel:Hide();
		TG_LastReport_SilverTexture:Show();
		TG_LastReport_CopperLabel:Hide();
		TG_LastReport_CopperTexture:Show();
		TG_EarningsPerHour_GoldLabel:Hide();
		TG_EarningsPerHour_GoldTexture:Show();
		TG_EarningsPerHour_SilverLabel:Hide();
		TG_EarningsPerHour_SilverTexture:Show();
		TG_EarningsPerHour_CopperLabel:Hide();
		TG_EarningsPerHour_CopperTexture:Show();
	else
		for i = 1, 9 do
			getglobal("TG_Character"..i.."_GoldLabel"):Show();
			getglobal("TG_Character"..i.."_GoldTexture"):Hide();
			getglobal("TG_Character"..i.."_SilverLabel"):Show();
			getglobal("TG_Character"..i.."_SilverTexture"):Hide();
			getglobal("TG_Character"..i.."_CopperLabel"):Show();
			getglobal("TG_Character"..i.."_CopperTexture"):Hide();
		end
		TG_Total_GoldLabel:Show();
		TG_Total_GoldTexture:Hide();
		TG_Total_SilverLabel:Show();
		TG_Total_SilverTexture:Hide();
		TG_Total_CopperLabel:Show();
		TG_Total_CopperTexture:Hide();
		TG_Session_GoldLabel:Show();
		TG_Session_GoldTexture:Hide();
		TG_Session_SilverLabel:Show();
		TG_Session_SilverTexture:Hide();
		TG_Session_CopperLabel:Show();
		TG_Session_CopperTexture:Hide();
		TG_LastReport_GoldLabel:Show();
		TG_LastReport_GoldTexture:Hide();
		TG_LastReport_SilverLabel:Show();
		TG_LastReport_SilverTexture:Hide();
		TG_LastReport_CopperLabel:Show();
		TG_LastReport_CopperTexture:Hide();
		TG_EarningsPerHour_GoldLabel:Show();
		TG_EarningsPerHour_GoldTexture:Hide();
		TG_EarningsPerHour_SilverLabel:Show();
		TG_EarningsPerHour_SilverTexture:Hide();
		TG_EarningsPerHour_CopperLabel:Show();
		TG_EarningsPerHour_CopperTexture:Hide();
	end

	local count = 0;
	for index, money in TotalGoldArray do
		local _, _, character, charserver = string.find(index, '(.*)_(.*)');
		if (character) then
			if (charserver == server) then
				count = count + 1;
				totalgold = totalgold + money;
				local line = "TG_Character"..count;
				getglobal(line.."_Character"):SetText(character);
				local width = getglobal(line.."_Character"):GetWidth();
				if (width > namewidth) then namewidth = width; end

				local gold = TG_GetGold(money);
				if (gold > 0) then
					getglobal(line.."_Gold"):SetText(gold);
					local width = getglobal(line.."_Gold"):GetWidth();
					if (width > goldwidth) then goldwidth = width; end
				else
					getglobal(line.."_GoldLabel"):Hide();
					getglobal(line.."_GoldTexture"):Hide();
					getglobal(line.."_Gold"):SetText("");
				end
				local silver = TG_GetSilver(money);
				if (silver > 0) then
					getglobal(line.."_Silver"):SetText(silver);
					local width = getglobal(line.."_Silver"):GetWidth();
					if (width > silverwidth) then silverwidth = width; end
				elseif (gold > 0) then
					getglobal(line.."_Silver"):SetText(silver);
					local width = getglobal(line.."_Silver"):GetWidth();
					if (width > silverwidth) then silverwidth = width; end
				else
					getglobal(line.."_Silver"):SetText("");
					getglobal(line.."_SilverLabel"):Hide();
					getglobal(line.."_SilverTexture"):Hide();
				end
				local copper = TG_GetCopper(money);
				getglobal(line.."_Copper"):SetText(copper);
				width = getglobal(line.."_Copper"):GetWidth();
				if (width > copperwidth) then copperwidth = width; end
			end
		end
	end

	local gold = TG_GetGold(totalgold);
	if (gold > 0) then
		TG_Total_Gold:SetText(gold);
		local width = TG_Total_Gold:GetWidth();
		if (width > goldwidth) then goldwidth = width; end
	else
		TG_Total_Gold:SetText("");
		TG_Total_GoldLabel:Hide();
		TG_Total_GoldTexture:Hide();
	end
	local silver = TG_GetSilver(totalgold);
	if (silver > 0) then
		TG_Total_Silver:SetText(silver);
		local width = TG_Total_Silver:GetWidth();
		if (width > silverwidth) then silverwidth = width; end
	elseif (gold >0) then
		TG_Total_Silver:SetText(silver);
		local width = TG_Total_Silver:GetWidth();
		if (width > silverwidth) then silverwidth = width; end
	else
		TG_Total_Silver:SetText("");
		TG_Total_SilverLabel:Hide();
		TG_Total_SilverTexture:Hide();
	end
	TG_Total_Copper:SetText(TG_GetCopper(totalgold));
	local width = TG_Total_Copper:GetWidth();
	if (width > copperwidth) then copperwidth = width; end

	local totaltext = "TG_Session";
	local negative = "";
	if (sessiontotal < 0) then
		negative = "-";
		sessiontotal = math.abs(sessiontotal);
	end
	gold = TG_GetGold(sessiontotal);
	if (gold > 0) then
		getglobal(totaltext.."_Gold"):SetText(negative..gold);
		local width = getglobal(totaltext.."_Gold"):GetWidth();
		if (width > goldwidth) then goldwidth = width; end
		negative = "";
	else
		getglobal(totaltext.."_Gold"):SetText("");
		getglobal(totaltext.."_GoldLabel"):Hide();
		getglobal(totaltext.."_GoldTexture"):Hide();
	end
	silver = TG_GetSilver(sessiontotal);
	if (silver > 0) then
		getglobal(totaltext.."_Silver"):SetText(negative..silver);
		local width = getglobal(totaltext.."_Silver"):GetWidth();
		if (width > silverwidth) then silverwidth = width; end
		negative = "";
	elseif (gold >0) then
		TG_Total_Silver:SetText(silver);
		local width = TG_Total_Silver:GetWidth();
		if (width > silverwidth) then silverwidth = width; end
	else
		getglobal(totaltext.."_Silver"):SetText("");
		getglobal(totaltext.."_SilverLabel"):Hide();
		getglobal(totaltext.."_SilverTexture"):Hide();
	end
	getglobal(totaltext.."_Copper"):SetText(negative..TG_GetCopper(sessiontotal));
	local width = getglobal(totaltext.."_Copper"):GetWidth();
	if (width > copperwidth) then copperwidth = width; end

	totaltext = "TG_LastReport";
	negative = "";
	if (lasttotal < 0) then
		negative = "-";
		lasttotal = math.abs(lasttotal);
	end
	gold = TG_GetGold(lasttotal);
	if (gold > 0) then
		getglobal(totaltext.."_Gold"):SetText(negative..gold);
		local width = getglobal(totaltext.."_Gold"):GetWidth();
		if (width > goldwidth) then goldwidth = width; end
		negative = "";
	else
		getglobal(totaltext.."_Gold"):SetText("");
		getglobal(totaltext.."_GoldLabel"):Hide();
		getglobal(totaltext.."_GoldTexture"):Hide();
	end
	silver = TG_GetSilver(lasttotal);
	if (silver > 0) then
		getglobal(totaltext.."_Silver"):SetText(negative..silver);
		local width = getglobal(totaltext.."_Silver"):GetWidth();
		if (width > silverwidth) then silverwidth = width; end
		negative = "";
	elseif (gold >0) then
		TG_Total_Silver:SetText(silver);
		local width = TG_Total_Silver:GetWidth();
		if (width > silverwidth) then silverwidth = width; end
	else
		getglobal(totaltext.."_Silver"):SetText("");
		getglobal(totaltext.."_SilverLabel"):Hide();
		getglobal(totaltext.."_SilverTexture"):Hide();
	end
	getglobal(totaltext.."_Copper"):SetText(negative..TG_GetCopper(lasttotal));
	local width = getglobal(totaltext.."_Copper"):GetWidth();
	if (width > copperwidth) then copperwidth = width; end

	totaltext = "TG_EarningsPerHour";
	negative = "";
	if (perhour < 0) then
		negative = "-";
		perhour = math.abs(perhour);
	end
	gold = TG_GetGold(perhour);
	if (gold > 0) then
		getglobal(totaltext.."_Gold"):SetText(negative..gold);
		local width = getglobal(totaltext.."_Gold"):GetWidth();
		if (width > goldwidth) then goldwidth = width; end
		negative = "";
	else
		getglobal(totaltext.."_Gold"):SetText("");
		getglobal(totaltext.."_GoldLabel"):Hide();
		getglobal(totaltext.."_GoldTexture"):Hide();
	end
	silver = TG_GetSilver(perhour);
	if (silver > 0) then
		getglobal(totaltext.."_Silver"):SetText(negative..silver);
		local width = getglobal(totaltext.."_Silver"):GetWidth();
		if (width > silverwidth) then silverwidth = width; end
		negative = "";
	elseif (gold >0) then
		TG_Total_Silver:SetText(silver);
		local width = TG_Total_Silver:GetWidth();
		if (width > silverwidth) then silverwidth = width; end
	else
		getglobal(totaltext.."_Silver"):SetText("");
		getglobal(totaltext.."_SilverLabel"):Hide();
		getglobal(totaltext.."_SilverTexture"):Hide();
	end
	getglobal(totaltext.."_Copper"):SetText(negative..TG_GetCopper(perhour));
	local width = getglobal(totaltext.."_Copper"):GetWidth();
	if (width > copperwidth) then copperwidth = width; end

	copperwidth = copperwidth + TG_WOFFSET;
	silverwidth = silverwidth +  TG_WOFFSET;
	goldwidth = goldwidth +  TG_WOFFSET;

	TG_Total_Copper:SetWidth(copperwidth);
	TG_Session_Copper:SetWidth(copperwidth);
	TG_LastReport_Copper:SetWidth(copperwidth);
	TG_Total_Silver:SetWidth(silverwidth);
	TG_Session_Silver:SetWidth(silverwidth);
	TG_LastReport_Silver:SetWidth(silverwidth);
	TG_Total_Gold:SetWidth(goldwidth);
	TG_Session_Gold:SetWidth(goldwidth);
	TG_LastReport_Gold:SetWidth(goldwidth);
	TG_Lines_Gold:SetWidth(goldwidth);
	TG_Lines_Silver:SetWidth(silverwidth);
	TG_Lines_Copper:SetWidth(copperwidth);
	TG_EarningsPerHour_Gold:SetWidth(goldwidth);
	TG_EarningsPerHour_Silver:SetWidth(silverwidth);
	TG_EarningsPerHour_Copper:SetWidth(copperwidth);

	if (namewidth < TG_Total_Character:GetWidth()) then namewidth = TG_Total_Character:GetWidth(); end
	if (namewidth < TG_Session_Character:GetWidth()) then namewidth = TG_Session_Character:GetWidth(); end
	if (namewidth < TG_EarningsPerHour_Character:GetWidth()) then namewidth = TG_EarningsPerHour_Character:GetWidth(); end
	namewidth = namewidth +  TG_WOFFSET;
	TG_Total_Character:SetWidth(namewidth);
	TG_Session_Character:SetWidth(namewidth);
	TG_LastReport_Character:SetWidth(namewidth);
	TG_EarningsPerHour_Character:SetWidth(namewidth);
	local windowwidth = namewidth + goldwidth + silverwidth + copperwidth + 40 + TG_Lines_CopperLabel:GetWidth();
	if (windowwidth < TG_Server:GetWidth()) then windowwidth = TG_Server:GetWidth(); end
	if (windowwidth < 220) then windowwidth = 220; end
	TG_WindowBG_Main1:SetWidth(windowwidth + 20);
	TotalGoldFrame:SetWidth(windowwidth + 40);
	TG_Lines_Character:SetWidth(namewidth);

	for i = 1, 12 do
		local line = "TG_Character"..i;
		if (i > count) then
			getglobal(line):Hide();
		else
			getglobal(line):SetWidth(windowwidth);
			getglobal(line.."_Character"):SetWidth(namewidth);
			getglobal(line.."_Gold"):SetWidth(goldwidth);
			getglobal(line.."_Silver"):SetWidth(silverwidth);
			getglobal(line.."_Copper"):SetWidth(copperwidth);
		end
	end

	TG_Lines:SetPoint("TOPLEFT", "TG_Character"..count, "BOTTOMLEFT", 0, 7);

	local windowheight = count * 20 + 185;
	TG_WindowBG_Main1:SetHeight(windowheight);
	TotalGoldFrame:SetHeight(windowheight + 20);

	TotalGoldFrame:Show();
	TG_WOFFSET = 0;
end

function TG_GetGold(money)
	if (money < 10000) then
		return 0;
	end
	local gold = tonumber(string.sub(money, 1, -5));
	return gold;
end

function TG_GetSilver(money)
	if (money < 100) then
		return 0;
	end
	local silver = tonumber(string.sub(money, -4, -3));
	return silver;
end

function TG_GetCopper(money)
	local copper = tonumber(string.sub(money, -2));
	return copper;
end